import io.gitlab.jfronny.scripts.*

plugins {
    commons.library
    kotlin("jvm")
}

dependencies {
    implementation(projects.commonsSerializeGson)

    testImplementation(kotlin("test"))
}

publishing {
    publications {
        create<MavenPublication>("maven") {
            groupId = "io.gitlab.jfronny"
            artifactId = "commons-gson-dsl"

            from(components["java"])
        }
    }
}

tasks.compileKotlin {
    destinationDirectory = tasks.compileJava.get().destinationDirectory.asFile.orNull
}

tasks.javadoc {
    enabled = false
    linksOffline("https://maven.frohnmeyer-wds.de/javadoc/artifacts/io/gitlab/jfronny/commons/$version/raw", projects.commons)
    linksOffline("https://maven.frohnmeyer-wds.de/javadoc/artifacts/io/gitlab/jfronny/commons-serialize/$version/raw", projects.commonsSerialize)
    linksOffline("https://maven.frohnmeyer-wds.de/javadoc/artifacts/io/gitlab/jfronny/commons-serialize-gson/$version/raw", projects.commonsSerializeGson)
    //TODO link gson javadoc (harder to generate than expected)
}
