package io.gitlab.jfronny.commons.serialize.gson.dsl

import io.gitlab.jfronny.gson.stream.JsonWriter

class ArrayScope(val writer: JsonWriter) {
    fun jObject(content: (@JsonDsl ObjectScope).() -> Unit) {
        writer.beginObject()
        ObjectScope(writer).content()
        writer.endObject()
    }

    fun jArray(content: (@JsonDsl ArrayScope).() -> Unit) {
        writer.beginArray()
        content()
        writer.endArray()
    }

    fun jValue(value: String) {
        writer.value(value)
    }

    fun jValue(value: Boolean) {
        writer.value(value)
    }

    fun jValue(value: Float) {
        writer.value(value)
    }

    fun jValue(value: Double) {
        writer.value(value)
    }

    fun jValue(value: Long) {
        writer.value(value)
    }

    fun jNull() {
        writer.nullValue()
    }

    fun jComment(comment: String) {
        writer.comment(comment)
    }
}