package io.gitlab.jfronny.muscript.gson.impl.typed;

import io.gitlab.jfronny.gson.TypeAdapter;
import io.gitlab.jfronny.gson.stream.*;
import io.gitlab.jfronny.muscript.data.dynamic.DString;
import io.gitlab.jfronny.muscript.data.dynamic.additional.DFinal;
import io.gitlab.jfronny.muscript.gson.impl.DynamicSerializer;

import java.io.IOException;

public class DStringSerializer extends TypeAdapter<DString> {
    private final DynamicSerializer base;

    public DStringSerializer(DynamicSerializer base) {
        this.base = base;
    }

    @Override
    public void write(JsonWriter w, DString dynamic) throws IOException {
        w.value(dynamic.getValue());
    }

    @Override
    public DString read(JsonReader r) throws IOException {
        if (r.peek() == JsonToken.STRING) return DFinal.of(r.nextString());
        else return base.read(r).asString();
    }
}
