package io.gitlab.jfronny.muscript.gson.impl.typed.additional;

import io.gitlab.jfronny.gson.TypeAdapter;
import io.gitlab.jfronny.gson.stream.JsonReader;
import io.gitlab.jfronny.gson.stream.JsonWriter;
import io.gitlab.jfronny.muscript.data.dynamic.additional.DEnum;

import java.io.IOException;

public class DEnumSerializer extends TypeAdapter<DEnum> {
    @Override
    public void write(JsonWriter w, DEnum dynamic) throws IOException {
        if (dynamic.value() == null) {
            w.beginArray();
            for (String s : dynamic.values().keySet()) {
                w.value(s);
            }
            w.endArray();
        } else w.value(dynamic.value().value());
    }

    @Override
    public DEnum read(JsonReader r) throws IOException {
        throw new UnsupportedOperationException("Deserializing DEnum is unsupported");
    }
}
