package io.gitlab.jfronny.muscript.ast;

import io.gitlab.jfronny.muscript.ast.dynamic.DynamicCoerce;
import io.gitlab.jfronny.muscript.compiler.*;

public abstract non-sealed class BoolExpr extends Expr<Boolean> {
    protected BoolExpr(Order order, CodeLocation location) {
        super(order, location);
    }

    @Override
    public Type getResultType() {
        return Type.Boolean;
    }

    @Override
    public abstract BoolExpr optimize();

    @Override
    public DynamicExpr asDynamicExpr() {
        return new DynamicCoerce(location, this);
    }
}
