package io.gitlab.jfronny.muscript.ast;

import io.gitlab.jfronny.muscript.ast.dynamic.DynamicCoerce;
import io.gitlab.jfronny.muscript.compiler.*;

public abstract non-sealed class NumberExpr extends Expr<Double> {
    protected NumberExpr(Order order, CodeLocation location) {
        super(order, location);
    }

    @Override
    public Type getResultType() {
        return Type.Number;
    }

    @Override
    public abstract NumberExpr optimize();

    @Override
    public DynamicExpr asDynamicExpr() {
        return new DynamicCoerce(location, this);
    }
}
