package io.gitlab.jfronny.muscript.ast;

import io.gitlab.jfronny.muscript.ast.dynamic.DynamicCoerce;
import io.gitlab.jfronny.muscript.compiler.*;

public abstract non-sealed class StringExpr extends Expr<String> {
    protected StringExpr(Order order, CodeLocation location) {
        super(order, location);
    }

    @Override
    public Type getResultType() {
        return Type.String;
    }

    @Override
    public abstract StringExpr optimize();

    @Override
    public DynamicExpr asDynamicExpr() {
        return new DynamicCoerce(location, this);
    }
}
