package io.gitlab.jfronny.muscript.ast.literal;

import io.gitlab.jfronny.muscript.ast.Expr;
import io.gitlab.jfronny.muscript.compiler.*;
import io.gitlab.jfronny.muscript.data.Scope;
import io.gitlab.jfronny.muscript.data.dynamic.Dynamic;
import io.gitlab.jfronny.muscript.ast.DynamicExpr;

import java.io.IOException;
import java.util.stream.Stream;

public final class DynamicLiteral<T> extends DynamicExpr {
    public final Dynamic value;

    public DynamicLiteral(CodeLocation location, Dynamic value) {
        super(Order.Primary, location);
        this.value = value;
    }

    @Override
    public Dynamic get(Scope dataRoot) {
        return value;
    }

    @Override
    public DynamicExpr optimize() {
        return this;
    }

    @Override
    public Stream<Expr<?>> extractSideEffects() {
        return Stream.empty();
    }

    @Override
    public void decompile(ExprWriter writer) throws IOException {
        value.serialize(writer);
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof DynamicLiteral<?> literal && value.equals(literal.value);
    }
}
