package io.gitlab.jfronny.muscript.ast.literal;

import io.gitlab.jfronny.commons.StringFormatter;
import io.gitlab.jfronny.muscript.ast.Expr;
import io.gitlab.jfronny.muscript.compiler.*;
import io.gitlab.jfronny.muscript.data.Scope;
import io.gitlab.jfronny.muscript.ast.NumberExpr;

import java.io.IOException;
import java.util.stream.Stream;

public final class NumberLiteral extends NumberExpr {
    public final double value;

    public NumberLiteral(CodeLocation location, double value) {
        super(Order.Primary, location);
        this.value = value;
    }

    @Override
    public Double get(Scope dataRoot) {
        return value;
    }

    @Override
    public NumberExpr optimize() {
        return this;
    }

    @Override
    public Stream<Expr<?>> extractSideEffects() {
        return Stream.empty();
    }

    @Override
    public void decompile(ExprWriter writer) throws IOException {
        writer.append(StringFormatter.toString(value));
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof NumberLiteral literal && value == literal.value;
    }
}
