package io.gitlab.jfronny.muscript.ast.literal;

import io.gitlab.jfronny.muscript.ast.Expr;
import io.gitlab.jfronny.muscript.ast.StringExpr;
import io.gitlab.jfronny.muscript.compiler.*;
import io.gitlab.jfronny.muscript.data.Scope;

import java.io.IOException;
import java.util.stream.Stream;

public final class StringLiteral extends StringExpr {
    public final String value;

    public StringLiteral(CodeLocation location, String value) {
        super(Order.Primary, location);
        this.value = value;
    }

    @Override
    public String get(Scope dataRoot) {
        return value;
    }

    @Override
    public StringExpr optimize() {
        return this;
    }

    @Override
    public Stream<Expr<?>> extractSideEffects() {
        return Stream.empty();
    }

    @Override
    public void decompile(ExprWriter writer) throws IOException {
        writer.append(enquote(value));
    }

    @Override
    public boolean equals(Object obj) {
        return obj instanceof StringLiteral literal && value.equals(literal.value);
    }
}
