package io.gitlab.jfronny.muscript.data.dynamic;

import io.gitlab.jfronny.muscript.ast.NullLiteral;
import io.gitlab.jfronny.muscript.compiler.CodeLocation;
import io.gitlab.jfronny.muscript.data.dynamic.type.DType;
import io.gitlab.jfronny.muscript.data.dynamic.type.DTypePrimitive;

public final class DNull implements Dynamic {
    @Override
    public Object getValue() {
        return null;
    }

    @Override
    public NullLiteral toExpr() {
        return new NullLiteral(CodeLocation.NONE);
    }

    @Override
    public DType getSignature() {
        return DTypePrimitive.NULL;
    }

    @Override
    public String toString() {
        return "null";
    }
}
