package io.gitlab.jfronny.muscript.error;

import io.gitlab.jfronny.muscript.compiler.CodeLocation;
import io.gitlab.jfronny.muscript.compiler.Type;
import org.jetbrains.annotations.Nullable;

/**
 * An exception that expresses an unexpected type
 * To be used in expressions
 */
public class TypeMismatchException extends LocationalException {
    private final Type expected;
    private final @Nullable Type actual;

    public TypeMismatchException(CodeLocation location, Type expected, @Nullable Type actual) {
        this(location, expected, actual, "Expected " + expected + (actual == null ? "" : " but got " + actual));
    }

    public TypeMismatchException(CodeLocation location, Type expected, @Nullable Type actual, String message) {
        super(location, message);
        this.expected = expected;
        this.actual = actual;
    }
}
