package io.gitlab.jfronny.muscript.libs;

import io.gitlab.jfronny.muscript.compiler.MuScriptVersion;
import io.gitlab.jfronny.muscript.data.Scope;
import io.gitlab.jfronny.muscript.data.Script;
import io.gitlab.jfronny.muscript.data.dynamic.DList;
import io.gitlab.jfronny.muscript.data.dynamic.Dynamic;
import io.gitlab.jfronny.muscript.data.dynamic.additional.DFinal;

import java.util.List;

import static io.gitlab.jfronny.muscript.data.dynamic.type.DSL.*;

public class IOLib {
    public static Scope addTo(MuScriptVersion version, Scope scope, IOWrapper io) {
        if (version.contains(MuScriptVersion.V3)) {
            scope.set("readString", callable(STRING, arg("fileName", STRING)), args -> {
                if (args.size() != 1) throw new SignatureDesyncException("readString");
                return DFinal.of(io.readString(args.get(0).asString().getValue()));
            }).set("runScript", callable(null, arg("fileName", STRING), arg("args", null, true)), args -> {
                if (args.isEmpty()) throw new SignatureDesyncException("runScript");
                Script script = io.parseScript(args.get(0).asString().getValue());
                List<? extends Dynamic> l = args.getValue();
                DList innerArgs = DFinal.of(l.subList(1, l.size()));
                return script.bindTo(scope.fork()).call(innerArgs);
            });
        }
        return scope;
    }
}
