package io.gitlab.jfronny.muscript.test;

import io.gitlab.jfronny.muscript.error.LocationalException;
import org.junit.jupiter.api.Test;

import static io.gitlab.jfronny.muscript.test.util.MuTestUtil.makeArgs;
import static io.gitlab.jfronny.muscript.test.util.MuTestUtil.parseScript;
import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertThrows;

class GlobalTest {
    @Test
    void notAll() {
        assertEquals(12, parseScript("""
                v = 12
                {->v = 5}()
                v
                """).run(makeArgs()).asNumber().getValue());
    }

    @Test
    void global() {
        assertEquals(5, parseScript("""
                $v = 12
                {->$v = 5}()
                $v
                """).run(makeArgs()).asNumber().getValue());
    }

    @Test
    void innermost() {
        assertThrows(LocationalException.class,
                () -> parseScript("""
                        {->$v = 12}()
                        $v
                        """).run(makeArgs()).asNumber().getValue(),
                "This object doesn't contain '$v'");
    }
}
